//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%43AB119903C8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%43AB119903C8.cm

//## begin module%43AB119903C8.cp preserve=no
//## end module%43AB119903C8.cp

//## Module: UniqueEnergyManager%43AB119903C8; Package specification
//## Subsystem: XSModel::Model%368927CA4068
//	/local/data/verisB/dorman/Xspec/src/model
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/UniqueEnergyManager.h

#ifndef UNIQUEENERGYMANAGER_H
#define UNIQUEENERGYMANAGER_H 1

//## begin module%43AB119903C8.additionalIncludes preserve=no
//## end module%43AB119903C8.additionalIncludes

//## begin module%43AB119903C8.includes preserve=yes
#include <xsTypes.h>
#include <set>
#include <map>

class Response;
//## end module%43AB119903C8.includes


class UniqueEnergy;

//## begin module%43AB119903C8.declarations preserve=no
//## end module%43AB119903C8.declarations

//## begin module%43AB119903C8.additionalDeclarations preserve=yes
//## end module%43AB119903C8.additionalDeclarations


//## begin UniqueEnergyManager%43AB1303034A.preface preserve=yes
//## end UniqueEnergyManager%43AB1303034A.preface

//## Class: UniqueEnergyManager%43AB1303034A
//## Category: XSModel::Model%36349D1B0171
//## Subsystem: XSModel::Model%368927CA4068
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%43AB133D0035;UniqueEnergy { -> F}

class UniqueEnergyManager 
{
  //## begin UniqueEnergyManager%43AB1303034A.initialDeclarations preserve=yes
  //## end UniqueEnergyManager%43AB1303034A.initialDeclarations

  public:
    //## Class: NameLookup%43C4281C0128
    //## Category: XSModel::Model%36349D1B0171
    //## Subsystem: XSModel::Model%368927CA4068
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::multimap<string,std::pair<size_t, UniqueEnergy*> > NameLookup;

    //## Class: SpecNumMap%4411A862014B
    //## Category: XSModel::Model%36349D1B0171
    //## Subsystem: XSModel::Model%368927CA4068
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::map<size_t,UniqueEnergy*> SpecNumMap;

    //## Constructors (specified)
      //## Operation: UniqueEnergyManager%43AB1470027B
      UniqueEnergyManager ();

    //## Destructor (generated)
      ~UniqueEnergyManager();


    //## Other Operations (specified)
      //## Operation: addRespEnergy%43AB296600B8
      bool addRespEnergy (const Response* response, bool isSpecDependent);

      //## Operation: removeRespEnergy%43AB29B501A7
      void removeRespEnergy (const Response* response);

      //## Operation: clearAll%43C7E6690192
      void clearAll ();

      //## Operation: updateEnergyFromResponse%44119FBF0268
      void updateEnergyFromResponse (const Response* response);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: uniqueEnergies%43AB27E40059
      std::set<UniqueEnergy*>& uniqueEnergies ();

  public:
    // Additional Public Declarations
      //## begin UniqueEnergyManager%43AB1303034A.public preserve=yes
      //## end UniqueEnergyManager%43AB1303034A.public

  protected:
    // Additional Protected Declarations
      //## begin UniqueEnergyManager%43AB1303034A.protected preserve=yes
      //## end UniqueEnergyManager%43AB1303034A.protected

  private:
    //## Constructors (generated)
      UniqueEnergyManager(const UniqueEnergyManager &right);

    //## Assignment Operation (generated)
      UniqueEnergyManager & operator=(const UniqueEnergyManager &right);


    //## Other Operations (specified)
      //## Operation: checkIfUnique%43AB2AC000F5
      UniqueEnergy* checkIfUnique (const RealArray& energies, const StringArray& rmfNames, const std::vector<Real>& gainFactor);

      //## Operation: findRmfNames%43AC61F102E5
      static void findRmfNames (const Response* response, StringArray& rmfNames);

    // Additional Private Declarations
      //## begin UniqueEnergyManager%43AB1303034A.private preserve=yes
      //## end UniqueEnergyManager%43AB1303034A.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin UniqueEnergyManager::uniqueEnergies%43AB27E40059.attr preserve=no  public: std::set<UniqueEnergy*> {U} 
      std::set<UniqueEnergy*> m_uniqueEnergies;
      //## end UniqueEnergyManager::uniqueEnergies%43AB27E40059.attr

      //## Attribute: specNumLookup%43AB28C502A1
      //## begin UniqueEnergyManager::specNumLookup%43AB28C502A1.attr preserve=no  private: UniqueEnergyManager::SpecNumMap {U} 
      UniqueEnergyManager::SpecNumMap m_specNumLookup;
      //## end UniqueEnergyManager::specNumLookup%43AB28C502A1.attr

      //## Attribute: rmfNameLookup%43AC3FF402E4
      //## begin UniqueEnergyManager::rmfNameLookup%43AC3FF402E4.attr preserve=no  private: UniqueEnergyManager::NameLookup {U} 
      UniqueEnergyManager::NameLookup m_rmfNameLookup;
      //## end UniqueEnergyManager::rmfNameLookup%43AC3FF402E4.attr

    // Additional Implementation Declarations
      //## begin UniqueEnergyManager%43AB1303034A.implementation preserve=yes
      //## end UniqueEnergyManager%43AB1303034A.implementation

};

//## begin UniqueEnergyManager%43AB1303034A.postscript preserve=yes
//## end UniqueEnergyManager%43AB1303034A.postscript

// Class UniqueEnergyManager 

//## Get and Set Operations for Class Attributes (inline)

inline std::set<UniqueEnergy*>& UniqueEnergyManager::uniqueEnergies ()
{
  //## begin UniqueEnergyManager::uniqueEnergies%43AB27E40059.get preserve=no
  return m_uniqueEnergies;
  //## end UniqueEnergyManager::uniqueEnergies%43AB27E40059.get
}

//## begin module%43AB119903C8.epilog preserve=yes
//## end module%43AB119903C8.epilog


#endif
